=== debian/control ===
Source: ros-iron-urdfdom
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), cmake, libconsole-bridge-dev, libtinyxml-dev, python3-dev <!nocheck>, ros-iron-console-bridge-vendor, ros-iron-tinyxml-vendor, ros-iron-urdfdom-headers (>= 0.2.3), ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-urdfdom
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libconsole-bridge-dev, libtinyxml-dev, ros-iron-console-bridge-vendor, ros-iron-tinyxml-vendor, ros-iron-urdfdom-headers (>= 0.2.3), ros-iron-ros-workspace
Description: A library to access URDFs using the DOM model.
